clear all;
load('raw_data.mat');
load('../data/blossom.mat');
close all;

itf = 1;
irot = 1;

for id = 1:size(d,2)
    
    f = figure(id);
    subplot(211);  
    loglog(ls1,data_blossom_pth(id).*ones(1,size(ls1,2)),'k--');
    hold on;
    for i2 = 1:size(ls2,2)
        errorbar(ls1,max(data_tf_test_pth(id,:,i2,2,2),[],[4 5]),z999.*max(data_tf_test_pth_ds(id,:,i2,2,2),[],[4 5]));
    end
    xlabel('Layer Size 1');
    ylabel('Pth');
    title(['Distance ' num2str(d(id))]);
    grid on;
    xticks(ls1);
    xticklabels(ls1);
    leg = cell(1 + size(ls2,2),1);
    leg(1) = {'MWPM'};
    leg(2:end) = mat2cell(num2str(ls2'),ones(1,size(ls2,2)),size(num2str(ls2'),2))';
    legend(leg, 'Location', 'SouthEast');
    
    subplot(212);    
    loglog(ls2,data_blossom_pth(id).*ones(1,size(ls2,2)),'k--');
    hold on;
    for i1 = 1:size(ls1,2)
        errorbar(ls2,squeeze(max(data_tf_test_pth(id,i1,:,2,2),[],[4 5])),z999.*squeeze(max(data_tf_test_pth_ds(id,i1,:,2,2),[],[4 5])));
    end
    xlabel('Layer Size 2');
    ylabel('Pth');
    grid on;
    xticks(ls2);
    xticklabels(ls2);
    leg = cell(1 + size(ls1,2),1);
    leg(1) = {'Blossom'};
    leg(2:end) = mat2cell(num2str(ls1'),ones(1,size(ls1,2)),size(num2str(ls1'),2))';
    legend(leg, 'Location', 'SouthEast');
        
    f.PaperType = 'a5';
    f.PaperSize = f.PaperSize ./ [1 1.8];
    f.PaperOrientation = 'portrait';
    %print(['../plots/layer_size/ls_d' num2str(d(id))],'-dpdf','-fillpage');
end

f = figure(size(d,2)+1);
for id = 1:size(d,2)
    subplotpos = [1 2 5 6];
    subfigure = ['a' 'b' 'c' 'd' 'e' 'f' 'g' 'h'];
    subplot(size(d,2),2,subplotpos(id));  
    loglog(ls1,data_blossom_pth(id).*ones(1,size(ls1,2)),'k--');
    hold on;
    for i2 = 1:size(ls2,2)
        errorbar(ls1,max(data_tf_test_pth(id,:,i2,2,2),[],[4 5]),z999.*max(data_tf_test_pth_ds(id,:,i2,2,2),[],[4 5]));
    end
    xlabel({'Layer Size 1';['(' subfigure(subplotpos(id)) ')']});
    ylabel('Pth');
    title(['Distance ' num2str(d(id))]);
    grid on;
    xticks(ls1);
    xticklabels(ls1);
    leg = cell(1 + size(ls2,2),1);
    leg(1) = {'Blossom'};
    leg(2:end) = mat2cell(num2str(ls2'),ones(1,size(ls2,2)),size(num2str(ls2'),2))';
    legend(leg, 'Location', 'SouthEast','FontSize',7);
    
    subplot(size(d,2),2,subplotpos(id)+2);  
    loglog(ls2,data_blossom_pth(id).*ones(1,size(ls2,2)),'k--');
    hold on;
    for i1 = 1:size(ls1,2)
        errorbar(ls2,squeeze(max(data_tf_test_pth(id,i1,:,2,2),[],[4 5])),z999.*squeeze(max(data_tf_test_pth_ds(id,i1,:,2,2),[],[4 5])));
    end
    xlabel({'Layer Size 2';['(' subfigure(subplotpos(id)+2) ')']});
    ylabel('Pth');
    grid on;
    xticks(ls2);
    xticklabels(ls2);
    leg = cell(1 + size(ls1,2),1);
    leg(1) = {'Blossom'};
    leg(2:end) = mat2cell(num2str(ls1'),ones(1,size(ls1,2)),size(num2str(ls1'),2))';
    legend(leg, 'Location', 'SouthEast','FontSize',7);
        
end

f.PaperType = 'a4';
f.PaperOrientation = 'portrait';
f.PaperSize = f.PaperSize .* [1 .9];
%print('../plots/layer_size/ls_all','-dpdf','-fillpage');

%%
f = figure(size(d,2)+2);
for id = 1:size(d,2)
    loglog(ls1,data_blossom_pth(id).*ones(1,size(ls1,2)),'--','Color',c(id,:),'LineWidth',1,'HandleVisibility','off');
    hold on;
    loglog([0 0],[0 0],'Color',c(id,:));
end
for id = 1:size(d,2)
    for i2 = [1 size(ls2,2)]
        %if(i2 == 1 || i2 == size(ls2,2))
            errorbar(ls1,max(data_tf_test_pth(id,:,i2,2,2),[],[4 5]),z999.*max(data_tf_test_pth_ds(id,:,i2,2,2),[],[4 5]),'Color',c(id,:),'LineWidth',1,'HandleVisibility','off');
        %else
            %errorbar(ls1,max(data_tf_test_pth(id,:,i2,2,2),[],[4 5]),z999.*max(data_tf_test_pth_ds(id,:,i2,2,2),[],[4 5]),'Color',(c(id,:)+[1 1 1])./2,'LineWidth',1);
        %end
    end   
end
xlabel('Layer Size 1');
ylabel('p_{th}');
%title(['Distance ' num2str(d(id))]);
grid on;
xticks(ls1);
xticklabels(ls1);  
legend('Distance 3','Distance 5','Distance 7','Distance 9','Location','SouthEast');

f.PaperType = 'a5';
f.PaperOrientation = 'portrait';
f.PaperSize = f.PaperSize ./ [1 1.8];
%print('../plots/layer_size/ls_all_merged','-dpdf','-fillpage');

%%
f = figure(size(d,2)+3);
for id = 1:size(d,2)
    loglog(ls2,data_blossom_pth(id).*ones(1,size(ls2,2)),'--','Color',c(id,:),'LineWidth',1);
    hold on;
    for i1 = 1:(size(ls1,2)-1)
        %if(i2 == 1 || i2 == size(ls2,2))
            %errorbar(ls1,max(data_tf_test_pth(id,:,i2,2,2),[],[4 5]),z999.*max(data_tf_test_pth_ds(id,:,i2,2,2),[],[4 5]),'Color',c(id,:),'LineWidth',1);
        %else
            %errorbar(ls2,squeeze(max(data_tf_test_pth(id,i1,:,2,2),[],[4 5])),z999.*squeeze(max(data_tf_test_pth_ds(id,i1,:,2,2),[],[4 5])),'--','Color',(c(id,:)+[1 1 1])./2,'LineWidth',.5);
        %end
    end
end
for id = 1:size(d,2)
    for i1 = 1:size(ls1,2)
        %if(i2 == 1 || i2 == size(ls2,2))
            errorbar(ls2,squeeze(max(data_tf_test_pth(id,i1,:,2,2),[],[4 5])),z999.*squeeze(max(data_tf_test_pth_ds(id,i1,:,2,2),[],[4 5])),'Color',c(id,:),'LineWidth',1);
        %else
            %errorbar(ls1,max(data_tf_test_pth(id,:,i2,2,2),[],[4 5]),z999.*max(data_tf_test_pth_ds(id,:,i2,2,2),[],[4 5]),'Color',(c(id,:)+[1 1 1])./2,'LineWidth',1);
        %end
    end   
end
xlabel('Layer Size 2');
ylabel('Pth');
%title(['Distance ' num2str(d(id))]);
grid on;
xticks(ls2);
xticklabels(ls2);     

f.PaperType = 'a5';
f.PaperOrientation = 'portrait';
f.PaperSize = f.PaperSize ./ [1 1.8];
%print('../plots/layer_size/ls2_all_merged','-dpdf','-fillpage');

%%
for(id = 1:4)
    figure(100 + id);
    loglog([min(ls1) max(ls1)],data_blossom_pth(id)*[1 1],'k--');
    hold on;
    for(irot = 1:2)
        %figure(100 + id + 10*(irot-1));
        loglog(ls1,data_tf_test_pth(id,:,1,1,irot),'Color',c(1+3*(irot-1),:));
        loglog(ls1,data_tf_test_pth(id,:,1,2,irot),'Color',c(2+3*(irot-1),:));
        loglog(ls1,data_tf_test_pth(id,:,1,3,irot),'Color',c(3+3*(irot-1),:));
        for(i2 = 2:size(ls2,2))
            loglog(ls1,data_tf_test_pth(id,:,i2,1,irot),'Color',c(1+3*(irot-1),:),'HandleVisibility','off');
            loglog(ls1,data_tf_test_pth(id,:,i2,2,irot),'Color',c(2+3*(irot-1),:),'HandleVisibility','off');
            loglog(ls1,data_tf_test_pth(id,:,i2,3,irot),'Color',c(3+3*(irot-1),:),'HandleVisibility','off');
        end
    end
    legend('mwpm','unrot tanh','unrot sqnl','unrot relu','rot tanh','rot sqnl','rot relu','Location','SouthEast');
end