clear all; close all;

%[ha,pos] = tight_subplot(4,3,[.005 .015],[.1 .01],[.1 .01]);
    
AxB_trans;

d = [3 5 7 9];
NNin = [8 24 48 80];
%pthf = [ 0.09762, 0.12659, 0.12592, 0.11800];
%blossom = [ 0.08234, 0.10343, 0.11366, 0.11932];

%load('../data/data_hardware/data_per.mat');
load('../data/data_hardware/data_node_time.mat');
load('../data/data_hardware/data_node_area.mat');
%load('data_node_power_tot.mat');
load('raw_data.mat');
load('../data/blossom.mat');
load('slope_data.mat');

data_time = data_time/1e3;
data_area_log = data_area_log/1e6;
%data_power_log = data_power_log/1e9;

%%
for dd = 1:numel(d)
    for ii = 2:8
        for jj = 2:6
            for b = 3:9
                qmax = data_quant_bits_pth(dd,1,ii-1,jj-1,b-2);
                smax = data_quant_bits_pth_ds(dd,1,ii-1,jj-1,b-2);
                slopemax = data_quant_bits_slope(dd,1,ii-1,jj-1,b-2);
                for q = 2:8
                   if(data_quant_bits_pth(dd,q-1,ii-1,jj-1,b-2) > qmax)
                       qmax = data_quant_bits_pth(dd,q-1,ii-1,jj-1,b-2);
                       smax = data_quant_bits_pth_ds(dd,q-1,ii-1,jj-1,b-2);
                       slopemax = data_quant_bits_slope(dd,q-1,ii-1,jj-1,b-2);
                   end
                end
                pth(ii*100+jj*10+b) = qmax;
                spth(ii*100+jj*10+b) = smax;
                slopeth(ii*100+jj*10+b) = slopemax;
                %pth(ii*100+jj*10+b) = data_tf_test_pth(dd,ii-1,jj-1,3,2);
                %spth(ii*100+jj*10+b) = data_tf_test_pth_ds(dd,ii-1,jj-1,3,2);
                delay(ii*100+jj*10+b) = data_time(NNin(dd),b,1,b) + ...
                                        data_time(2^ii,b,b,b) + ...
                                        data_time(2^jj,b,b,1);
                area(ii*100+jj*10+b) = 2^ii * data_area_log(NNin(dd),b,1,b) + ...
                                        2^jj * data_area_log(2^ii,b,b,b) + ...
                                        2 * data_area_log(2^jj,b,b,1);
%                 power(ii*100+jj*10+b) = 2^ii * data_power_log(NNin(dd),b,1,b) + ...
%                                         2^jj * data_power_log(2^ii,b,b,b) + ...
%                                         2 * data_power_log(2^jj,b,b,1);
                power(ii*100+jj*10+b) = (2^ii * x(1) * NNin(dd) * b + x(2) * floor(log2(NNin(dd))) + x(3) * b^2 + x(4) * b + ...
                                        2^jj * y(1) * 2^ii * b^2 + y(2) * log2(2^ii) + y(3) * b^2 + y(4) * b + ...
                                        2 * z(1) * 2^jj * b^2 + z(2) *log2(2^jj) + z(3) * b^2 + z(4) * b) / 1e6;

            end
            
        end        
    end
    
    %% delay pareto
    % find minimum delay
    ll = [];
    mindelay = max(delay);
    maxpth = pth(1);
    iipthmax = 1;
    iidelay = 1;
    
    % find non zero elements and starting points
    for m = 1:numel(delay)
       if(delay(m) > 0 && pth(m) > 0)
          ll = [ll m]; 
          if(delay(m) < mindelay)
              mindelay = delay(m);
              iidelay = m;
          end
          if(pth(m) > maxpth)
              maxpth = pth(m);
              iipthmax = m;
          end
       end
    end
       
    % find the minimum delay for all points where the pth NNin larger than
    % that of the minimum delay
    delay_ii = 0;
    delay_ii(1) = iidelay;
    kk = 2;
    % repeat until that point corresponds to the maximum pth
    while(iidelay ~= iipthmax)
        llnew = ll;
        for m = ll
            if(pth(m) <= pth(iidelay))
               llnew(llnew == m) = []; 
            end
        end
        ll = llnew;
        mindelay = delay(ll(1));
        iidelay = ll(1);
        for m = ll(2:end)
           if( delay(m) < mindelay)
               mindelay = delay(m);
               iidelay = m;
           end
        end
        delay_ii(kk) = iidelay;
        
        kk = kk + 1;
    end
    
    
    %% area pareto
    % find minimum area
    ll = [];
    minarea = max(area);
    maxpth = 0;
    iipthmax = 1;
    iiarea = 1;
    
    % find non zero elements and starting points
    for m = 1:numel(area)
       if(area(m) > 0 && pth(m) > 0)
          ll = [ll m]; 
          if(area(m) < minarea)
              minarea = area(m);
              iiarea = m;
          end
          if(pth(m) > maxpth)
              maxpth = pth(m);
              iipthmax = m;
          end
       end
    end
       
    % find the minimum area for all points where the pth NNin larger than
    % that of the minimum area
    area_ii = 0;
    area_ii(1) = iiarea;
    kk = 2;
    % repeat until that point corresponds to the maximum pth
    while(iiarea ~= iipthmax)
        llnew = ll;
        for m = ll
            if(pth(m) <= pth(iiarea))
               llnew(llnew == m) = []; 
            end
        end
        ll = llnew;
        minarea = area(ll(1));
        iiarea = ll(1);
        for m = ll(2:end)
           if( area(m) < minarea)
               minarea = area(m);
               iiarea = m;
           end
        end
        area_ii(kk) = iiarea;
        
        kk = kk + 1;
    end
    
    
    nzpth = find(pth > 0);
    
    %% power pareto
    % find minimum power
    ll = [];
    minpower = max(power);
    maxpth = pth(1);
    iipthmax = 1;
    iipower = 1;
    
    
    % find non zero elements and starting points
    for m = 1:numel(power)
       if(power(m) > 0 && pth(m) > 0)
          ll = [ll m]; 
          if(power(m) < minpower)
              minpower = power(m);
              iipower = m;
          end
          if(pth(m) > maxpth)
              maxpth = pth(m);
              iipthmax = m;
          end
       end
    end
       
    % find the minimum power for all points where the pth NNin larger than
    % that of the minimum power
    power_ii = 0;
    power_ii(1) = iipower;
    kk = 2;
    % repeat until that point corresponds to the maximum pth
    while(iipower ~= iipthmax)
        llnew = ll;
        for m = ll
            if(pth(m) <= pth(iipower))
               llnew(llnew == m) = []; 
            end
        end
        ll = llnew;
        minpower = power(ll(1));
        iipower = ll(1);
        for m = ll(2:end)
           if( power(m) < minpower)
               minpower = power(m);
               iipower = m;
           end
        end
        power_ii(kk) = iipower;
        
        kk = kk + 1;
    end
    
    %% all ii
    all_ii = [];
    ll = 1;
    for kk = 1:numel(delay_ii)
        for ii = 1:numel(area_ii)
           if(delay_ii(kk) == area_ii(ii))
              for jj = 1:numel(power_ii)
                  if(delay_ii(kk) == power_ii(jj))
                     all_ii(ll) = delay_ii(kk);
                     ll = ll + 1;
                  end
              end
           end
        end
    end
        
    %% plot
    
    f = figure(2);
    subplot(1,3,1);
    plot([0 30],[data_blossom_pth(dd),data_blossom_pth(dd)],'--','Color',c(dd,:),'LineWidth',1);
    hold on;
    plot(delay,pth,'.','Color',(c(dd,:) + [1 1 1])/2,'HandleVisibility','off');
    errorbar(delay(delay_ii),pth(delay_ii),spth(delay_ii),'vertical','-','Color',c(dd,:),'MarkerFaceColor',c(dd,:),'LineWidth',1,'HandleVisibility','off');
    grid on;
    xlabel('Delay (ns)');
    ylabel('p_{th}');
    ylim([0.05 0.13]);
    title(['p_{th} vs Delay']);
    
    subplot(1,3,2);
    semilogx([1e-4 1e1],[data_blossom_pth(dd),data_blossom_pth(dd)],'--','Color',c(dd,:),'LineWidth',1,'HandleVisibility','off');
    hold on;
    semilogx(area,pth,'.','Color',(c(dd,:) + [1 1 1])/2,'HandleVisibility','off');
    errorbar(area(area_ii),pth(area_ii),spth(area_ii),'vertical','-','Color',c(dd,:),'MarkerFaceColor',c(dd,:),'LineWidth',1);

    grid on;
    xlabel('Area (mm^2)');
    ylabel('p_{th}');
    ylim([0.05 0.13]);
    xlim([1e-4 1e1]);
    title(['p_{th} vs Area']);
    if(dd == 4)
        legend('Distance 3','Distance 5','Distance 7','Distance 9','Location','NorthWest');
    end    
    
    subplot(1,3,3);
    semilogx([0 0],[0 0],'.k',[0 0],[0 0],'-k',[0 0],[0 0],'--k');
    semilogx([1e-6 1e-1],[data_blossom_pth(dd),data_blossom_pth(dd)],'--','Color',c(dd,:),'LineWidth',1,'HandleVisibility','off');
    hold on;
    semilogx(power,pth,'.','Color',(c(dd,:) + [1 1 1])/2,'HandleVisibility','off');
    errorbar(power(power_ii),pth(power_ii),spth(power_ii),'vertical','-','Color',c(dd,:),'MarkerFaceColor',c(dd,:),'LineWidth',1,'HandleVisibility','off');

    grid on;
    xlabel('Power (W)');
    ylabel('p_{th}');
    ylim([0.05 0.13]);
    xlim([1e-6 1e-1]);
    title(['p_{th} vs Power']);
    if(dd == 4)
        legend('Data','Pareto','MWPM','Location','NorthWest');
    end
    

%% delay pareto
    % find minimum delay
    ll = [];
    mindelay = max(delay);
    maxslopeth = slopeth(1);
    iislopethmax = 1;
    iidelay = 1;
    
    % find non zero elements and starting points
    for m = 1:numel(delay)
       
       if(delay(m) > 0 && slopeth(m) > 0)
          ll = [ll m]; 
          if(delay(m) < mindelay)
              mindelay = delay(m);
              iidelay = m;
          end
          if(slopeth(m) > maxslopeth)
              maxslopeth = slopeth(m);
              iislopethmax = m;
          end
       end
    end
       
    % find the minimum delay for all points where the pth NNin larger than
    % that of the minimum delay
    delay_ii = 0;
    delay_ii(1) = iidelay;
    kk = 2;
    % repeat until that point corresponds to the maximum pth
    while(iidelay ~= iislopethmax)
        llnew = ll;
        for m = ll
            if(slopeth(m) <= slopeth(iidelay))
               llnew(llnew == m) = []; 
            end
        end
        ll = llnew;
        mindelay = delay(ll(1));
        iidelay = ll(1);
        for m = ll(2:end)
           if( delay(m) < mindelay)
               mindelay = delay(m);
               iidelay = m;
           end
        end
        delay_ii(kk) = iidelay;
        
        kk = kk + 1;
    end
    
    
    %% area pareto
    % find minimum area
    ll = [];
    minarea = max(area);
    maxslopeth = slopeth(1);
    iislopethmax = 1;
    iiarea = 1;
    
    % find non zero elements and starting points
    for m = 1:numel(area)
       
       if(area(m) > 0 && slopeth(m) > 0)
          ll = [ll m]; 
          if(area(m) < minarea)
              minarea = area(m);
              iiarea = m;
          end
          if(slopeth(m) > maxslopeth)
              maxslopeth = slopeth(m);
              iislopethmax = m;
          end
       end
    end
       
    % find the minimum area for all points where the pth NNin larger than
    % that of the minimum area
    area_ii = 0;
    area_ii(1) = iiarea;
    kk = 2;
    % repeat until that point corresponds to the maximum pth
    while(iiarea ~= iislopethmax)
        llnew = ll;
        for m = ll
            if(slopeth(m) <= slopeth(iiarea))
               llnew(llnew == m) = []; 
            end
        end
        ll = llnew;
        minarea = area(ll(1));
        iiarea = ll(1);
        for m = ll(2:end)
           if( area(m) < minarea)
               minarea = area(m);
               iiarea = m;
           end
        end
        area_ii(kk) = iiarea;
        
        kk = kk + 1;
    end
    
    
    nzslopeth = find(slopeth > 0);
    
    %% power pareto
    % find minimum power
    ll = [];
    minpower = max(power);
    maxslopeth = slopeth(1);
    iislopethmax = 1;
    iipower = 1;
    
    % find non zero elements and starting points
    for m = 1:numel(power)
       
       if(power(m) > 0 && slopeth(m) > 0)
          ll = [ll m]; 
          if(power(m) < minpower)
              minpower = power(m);
              iipower = m;
          end
          if(slopeth(m) > maxslopeth)
              maxslopeth = slopeth(m);
              iislopethmax = m;
          end
       end
    end
       
    % find the minimum power for all points where the pth NNin larger than
    % that of the minimum power
    power_ii = 0;
    power_ii(1) = iipower;
    kk = 2;
    % repeat until that point corresponds to the maximum pth
    while(iipower ~= iislopethmax)
        llnew = ll;
        for m = ll
            if(slopeth(m) <= slopeth(iipower))
               llnew(llnew == m) = []; 
            end
        end
        ll = llnew;
        minpower = power(ll(1));
        iipower = ll(1);
        for m = ll(2:end)
           if( power(m) < minpower)
               minpower = power(m);
               iipower = m;
           end
        end
        power_ii(kk) = iipower;
        
        kk = kk + 1;
    end
    
    %% all ii
    all_ii = [];
    ll = 1;
    for kk = 1:numel(delay_ii)
        for ii = 1:numel(area_ii)
           if(delay_ii(kk) == area_ii(ii))
              for jj = 1:numel(power_ii)
                  if(delay_ii(kk) == power_ii(jj))
                     all_ii(ll) = delay_ii(kk);
                     ll = ll + 1;
                  end
              end
           end
        end
    end

    
    f2 = figure(1);
    subplot(131);
    plot(delay,slopeth,'.','Color',(c(dd,:) + [1 1 1])/2);
    hold on;
    plot([0 30],[blossom_slope(dd) blossom_slope(dd)],'--','Color',c(dd,:));
    plot(delay(delay_ii),slopeth(delay_ii),'-','Color',c(dd,:),'MarkerFaceColor',c(dd,:),'LineWidth',1);
    grid on;
    ylim([1.5 5]);
    xlim([0 30]);
    xlabel('Delay (ns)');
    ylabel('Slope');
    title('Slope vs Delay');
    
    subplot(132);
    semilogx(area,slopeth,'.','Color',(c(dd,:) + [1 1 1])/2,'HandleVisibility','off');
    hold on;
    plot([1e-4 1e1],[blossom_slope(dd) blossom_slope(dd)],'--','Color',c(dd,:),'HandleVisibility','off');
    plot(area(area_ii),slopeth(area_ii),'-','Color',c(dd,:),'MarkerFaceColor',c(dd,:),'LineWidth',1);
    grid on;
    ylim([1.5 5]);
    xlim([1e-4 1e1]);
    xlabel('Area (mm^2)');
    ylabel('Slope');
    title('Slope vs Area');
    if(dd == 4)
        legend('Distance 3','Distance 5','Distance 7','Distance 9','Location','NorthWest');
    end
    
    subplot(133);
    semilogx([0 0],[0 0],'.k',[0 0],[0 0],'-k',[0 0],[0 0],'--k');
    semilogx(power,slopeth,'.','Color',(c(dd,:) + [1 1 1])/2,'HandleVisibility','off');
    hold on;
    plot([1e-6 1e-1],[blossom_slope(dd) blossom_slope(dd)],'--','Color',c(dd,:),'HandleVisibility','off');
    plot(power(power_ii),slopeth(power_ii),'-','Color',c(dd,:),'MarkerFaceColor',c(dd,:),'LineWidth',1,'HandleVisibility','off');
    grid on;
    ylim([1.5 5]);
    xlim([1e-6 1e-1]);
    xlabel('Power (W)');
    ylabel('Slope');
    title('Slope vs Power');
    if(dd == 4)
        legend('Data','Pareto','MWPM','Location','NorthWest');
    end
    
end

%%

f = figure(2);
f.PaperType = 'a4';
f.PaperOrientation = 'landscape';
f.PaperSize = f.PaperSize ./ [1 1.3];
%print(['../plots/pareto/pareto_all'],'-dpdf','-fillpage');

f2 = figure(1);
f2.PaperType = 'a4';
f2.PaperOrientation = 'landscape';
f2.PaperSize = f2.PaperSize ./ [1 1.3];
%print(['../plots/pareto/pareto_slope_all'],'-dpdf','-fillpage');
