clear all;
load('raw_data.mat');
load('slope_data.mat');
load('../data/blossom.mat');
close all;

marker = ['s','d','o','^','p','v'];

for id = 1:size(d,2)
   
    f = figure(id);
    
    leg = cell(1 + size(ls1,2)*size(ls2,2),1);
    leg(1) = {'Blossom'};
    
    %semilogy(bits,data_blossom_pth(id).*ones(size(bits,2),1),'k--');
    semilogy(bits,ones(size(bits,2),1),'k--');
    hold on;
    
    for i1 = 1:size(ls1,2)
        for i2 = 1:size(ls2,2)
            databits = squeeze(max(data_quant_bits_pth(id,:,i1,i2,:),[],2));
            datatest = squeeze(max(data_quant_test_pth(id,:,i1,i2),[],2));
            if(id == 1)
                if(squeeze(max(data_quant_test_slope(id,:,i1,i2),[],2)) >= 1)
                %datatest = data_blossom_pth(id).*ones(size(bits,2),1);
                    plot(bits,databits./datatest,['-' marker(i2)],'Color',c(i1,:));
                    leg(1 + (i1-1)*size(ls2,2)+i2) = {[num2str(ls1(i1)) ', ' num2str(ls2(i2))]};
                else
                    plot([2 2],[0 0],['-' marker(i2)],'Color',c(i1,:));
                    leg(1 + (i1-1)*size(ls2,2)+i2) = {''};
                end
            else
                if(squeeze(max(data_quant_test_slope(id,:,i1,i2),[],2)) >= blossom_slope(id-1))
                %datatest = data_blossom_pth(id).*ones(size(bits,2),1);
                    plot(bits,databits./datatest,['-' marker(i2)],'Color',c(i1,:));
                    leg(1 + (i1-1)*size(ls2,2)+i2) = {[num2str(ls1(i1)) ', ' num2str(ls2(i2))]};
                else
                    plot([2 2],[0 0],['-' marker(i2)],'Color',c(i1,:));
                    leg(1 + (i1-1)*size(ls2,2)+i2) = {''};
                end
            end
        end
    end
    %semilogy(bits,data_blossom_pth(id).*ones(size(bits,2),1),'k--');
    semilogy(bits,ones(size(bits,2),1),'k--');
    
    xlabel('Number of Fractional bits');
    ylabel('Quantized / Float');
    title(['Distance ' num2str(d(id))]);
    grid on;   
        
    legend(leg, 'Location', 'SouthEast','FontSize',7);
    
    
%     f.PaperType = 'a5';
%     f.PaperSize = f.PaperSize ./ [1 1.8];
%     f.PaperOrientation = 'portrait';
%     print(['../plots/quantization/q_d' num2str(d(id))],'-dpdf','-fillpage');
    
end

%%
f = figure(9);
for id = [4 3 2 1]
   
    subplot(4,1,id);
    %leg = cell(1 + size(ls1,2)*size(ls2,2),1);
    %leg(1) = {'Blossom'};
    
    semilogy(bits,ones(size(bits,2),1),'k--');
    hold on;
    
    for i1 = 1:size(ls1,2)
        for i2 = 1:size(ls2,2)
            for iq = 1:size(bits,2)
                databits = squeeze(data_quant_bits(id,iq,i1,i2,:,1));
                datatest = squeeze(data_quant_test(id,iq,i1,i2,1));
                plot(bits,databits./datatest,'Color',(c(id,:)+[1 1 1])./2,'LineWidth',0.1);
            end
        end
    end
    
    xlabel('Number of Fractional bits');
    ylabel('Quantized / Float');
    %title(['Distance ' num2str(d(id))]);
    grid on;   
    
end
for id = [4 3 2 1]
   
    subplot(4,1,id);
    %leg = cell(1 + size(ls1,2)*size(ls2,2),1);
    %leg(1) = {'Blossom'};
    
    semilogy(bits,ones(size(bits,2),1),'k--');
    hold on;
    
    for i1 = 1:size(ls1,2)
        for i2 = 1:size(ls2,2)
            for iq = 1:size(bits,2)
                if(id == 1)
                    iii=squeeze(data_quant_bits_slope(id,iq,i1,i2,:)) >= 1;
                    databits = squeeze(data_quant_bits(id,iq,i1,i2,:,1));
                    datatest = squeeze(data_quant_test(id,iq,i1,i2,1));
                    plot(bits(iii),databits(iii)./datatest,'Color',c(id,:),'LineWidth',0.1);
                    
                else
                    iii=squeeze(data_quant_bits_slope(id,iq,i1,i2,:)) >= max(squeeze(data_quant_test_slope(id-1,:,:,:)),[],'all');
                    databits = squeeze(data_quant_bits(id,iq,i1,i2,:,1));
                    datatest = squeeze(data_quant_test(id,iq,i1,i2,1));
                    plot(bits(iii),databits(iii)./datatest,'Color',c(id,:),'LineWidth',0.1);
                end
            end
        end
    end
    
    xlabel('Number of Fractional bits');
    ylabel('Quantized / Float');
    %title(['Distance ' num2str(d(id))]);
    grid on;   
    
end

f.PaperType = 'a5';
f.PaperSize = f.PaperSize ./ [1 1.8];
f.PaperOrientation = 'portrait';
%print(['../plots/quantization/q_ler_at_003)'],'-dpdf','-fillpage');

%%
for id = 1:size(d,2)
   
    f = figure(id+10);
    hold off;
    leg = cell(1 + size(ls1,2)*size(ls2,2),1);
    leg(1) = {'Blossom'};
    
    %semilogy(bits,data_blossom_pth(id).*ones(size(bits,2),1),'k--');
    semilogy(bits,ones(size(bits,2),1),'k--');
    hold on;
    
    for i1 = 1:size(ls1,2)
        for i2 = 1:size(ls2,2)
            databits = squeeze(max(data_quant_bits_slope(id,:,i1,i2,:),[],2));
            datatest = squeeze(max(data_quant_test_slope(id,:,i1,i2),[],2));
            %datatest = data_blossom_pth(id).*ones(size(bits,2),1);
            %if(datatest >= 1)
                plot(bits,databits./datatest,['-' marker(i2)],'Color',c(i1,:));
            %end
                leg(1 + (i1-1)*size(ls2,2)+i2) = {[num2str(ls1(i1)) ', ' num2str(ls2(i2))]};
        end
    end
    %semilogy(bits,data_blossom_pth(id).*ones(size(bits,2),1),'k--');
    semilogy(bits,ones(size(bits,2),1),'k--');
    
    xlabel('Number of Fractional bits');
    ylabel('Quantized / Float');
    title(['Distance ' num2str(d(id))]);
    grid on;   
        
    legend(leg, 'Location', 'SouthEast','FontSize',7);
    
    
%     f.PaperType = 'a5';
%     f.PaperSize = f.PaperSize ./ [1 1.8];
%     f.PaperOrientation = 'portrait';
%     print(['../plots/quantization/q_d' num2str(d(id))],'-dpdf','-fillpage');
    
end


%Normalized seperate
f = figure( size(d,2) + 1 );
for id = [1 2 4 3]
   subplot(4,1,id);
    semilogy(bits,ones(size(bits,2),1),'k--');
    hold on;
    
    %leg = cell(1 + size(ls1,2)*size(ls2,2),1);
    %leg(1) = {'MWPM'};
    
    mindata = 2*ones(size(bits,2),1);
    maxdata = zeros(size(bits,2),1);
    avgdata = zeros(size(bits,2),1);
    nn = 0;
    
    for i1 = 1:size(ls1,2)
        for i2 = 1:size(ls2,2)
            datatest = squeeze(max(data_quant_test_pth(id,:,i1,i2),[],2));
            if(datatest > 0)
                databits = squeeze(max(data_quant_bits_pth(id,:,i1,i2,:),[],2));
                dataplot = databits./datatest;
                avgdata = avgdata + dataplot;
                nn = nn + 1;
                for iq = 1:size(bits,2)
                    if(dataplot(iq) > maxdata(iq))
                        maxdata(iq) = dataplot(iq);
                    end
                    if(dataplot(iq) ~= 0 && dataplot(iq) < mindata(iq))
                        mindata(iq) = dataplot(iq);
                    end
                    %if(datatest >= data_blossom_pth(id))
                    %end
                    %leg(1 + (i1-1)*size(ls2,2)+i2) = {[num2str(ls1(i1)) ', ' num2str(ls2(i2))]};
                end
                semilogy(bits,dataplot,'-','Color',(c(id,:)+[2 2 2])./3);
            end
        end
    end
    
   avgdata = avgdata / nn;
   
    %fill([bits fliplr(bits)],[maxdata' fliplr(avgdata')],c(id,:),'EdgeColor',c(id,:),'FaceAlpha',0.4);
    %fill([bits fliplr(bits)],[avgdata' fliplr(mindata')],c(id,:),'EdgeColor',c(id,:),'FaceAlpha',0.4);
    %semilogy(bits,avgdata,'Color',c(id,:));
    errorbar(bits,avgdata,avgdata-mindata,maxdata-avgdata,'Color',c(id,:));

    semilogy(bits,ones(size(bits,2),1),'k--');   

    xlabel('Number of Fractional bits');
    ylabel('Quantized / Float');
    ylim([2e-1,1.1]);
    title(['Distance ' num2str(d(id))]);
    grid on; 
    
end

%legend(leg, 'Location', 'SouthEast','FontSize',7);

f.PaperType = 'a5';
f.PaperSize = f.PaperSize ./ [1 1];
f.PaperOrientation = 'portrait';
%print(['../plots/quantization/q_sep_norm'],'-dpdf','-fillpage');

%%
%Normalized together
f = figure( size(d,2) + 2 );
    
mindata = 2*ones(size(bits,2),size(d,2));
maxdata = zeros(size(bits,2),size(d,2));
avgdata = zeros(size(bits,2),size(d,2));
avgdata_frac = zeros(size(bits,2),size(d,2));
for id = 1:size(d,2)
    %subplot(4,1,id);
    semilogy(bits+1,ones(size(bits,2),1),'k--','HandleVisibility','off');
    hold on;
    
    %leg = cell(1 + size(ls1,2)*size(ls2,2),1);
    %leg(1) = {'MWPM'};
    nn = zeros(size(bits,2),1);
    
    for i1 = 1:size(ls1,2)
        for i2 = 1:size(ls2,2)
            for iq = 1:size(bits,2)
                datatest = squeeze(data_quant_test_pth(id,iq,i1,i2));
                %datatest = squeeze(min(data_quant_test(id,:,i1,i2,1),[],2));
                datatestslope = squeeze(data_quant_test_slope(id,iq,i1,i2));
                %bs = [1; blossom_slope];
                bs = [1; squeeze(max(data_quant_test_slope(:,:,:,:),[],[2 3 4]))];
                if(datatest > 0 && datatestslope >= bs(id))
                    databits = squeeze(data_quant_bits_pth(id,iq,i1,i2,:));
                    %databits = squeeze(min(data_quant_bits(id,:,i1,i2,:,1),[],2));
                    dataplot = databits./datatest;
                    dataplot_frac = (databits-[databits(2:end); datatest])./datatest;
                    %datamax = squeeze(max(data_quant_bits_pth_ds(id,:,i1,i2,:),[],2))./datatest;
                    %datamin = squeeze(max(data_quant_bits_pth_ds(id,:,i1,i2,:),[],2))./datatest;

                    valid = 1;
                    for ib = size(bits,2):-1:1
                        if(dataplot(ib) > 0 && valid == 1)
                            avgdata(ib,id) = avgdata(ib,id) + dataplot(ib);
                            avgdata_frac(ib,id) = avgdata_frac(ib,id) + dataplot_frac(ib);
                            nn(ib) = nn(ib) + 1;
                        elseif(dataplot(ib) > 0)
                            valid = 1;
                        else
                            valid = 0;
                        end

                        if(dataplot(ib) > maxdata(ib,id))
                            maxdata(ib,id) = dataplot(ib);
                        end
                        if(dataplot(ib) ~= 0 && dataplot(ib) < mindata(ib,id))
                            mindata(ib,id) = dataplot(ib);
                        end
                        %if(datatest >= data_blossom_pth(id))
                        %end
                        %leg(1 + (i1-1)*size(ls2,2)+i2) = {[num2str(ls1(i1)) ', ' num2str(ls2(i2))]};
                    end
                    semilogy(bits+1,dataplot,'-','Color',(c(id,:)+[1 1 1])./2,'LineWidth',0.5,'HandleVisibility','off');
                end
            end
        end
    end
    
   avgdata(:,id) = avgdata(:,id) ./ nn;
    
   avgdata_frac(:,id) = avgdata_frac(:,id) ./ nn;
end

%fill([bits fliplr(bits)],[maxdata' fliplr(avgdata')],c(id,:),'EdgeColor',c(id,:),'FaceAlpha',0.4);
%fill([bits fliplr(bits)],[avgdata' fliplr(mindata')],c(id,:),'EdgeColor',c(id,:),'FaceAlpha',0.4);
%semilogy(bits,avgdata,'Color',c(id,:));
for id = 1:size(d,2)
    %errorbar(bits,avgdata(:,id),avgdata(:,id)-mindata(:,id),maxdata(:,id)-avgdata(:,id),'Color',c(id,:));
    %semilogy(bits,avgdata(:,id),'-s','Color',c(id,:),'LineWidth',1.5,'MarkerFaceColor',c(id,:));
    avgplot(size(bits,2)) = 1;
    for ib = size(bits,2)-1:-1:1
        avgplot(ib) = avgplot(ib+1) + avgdata_frac(ib,id);
    end
    semilogy(bits+1,avgplot,'-d','Color',c(id,:),'LineWidth',2,'MarkerFaceColor',c(id,:));
end
%semilogy(bits,avgdata,'Color',c(id,:),'LineWidth',3);
%semilogy(bits,min(mindata,avgdata),'Color',c(id,:),'LineWidth',0.5,'HandleVisibility','off');
%semilogy(bits,maxdata,'Color',c(id,:),'LineWidth',0.5,'HandleVisibility','off');

semilogy(bits+1,ones(size(bits,2),1),'k--','HandleVisibility','off');   

xlabel('Number of bits');
ylabel('Quantized / Float');
%ylim([2e-1,1.1]);
%xlim([1.5,8.5]);
%title(['Distance ' num2str(d(id))]);
grid on; 

legend('Distance 3', 'Distance 5', 'Distance 7', 'Distance 9', 'Location', 'SouthEast','FontSize',7);

f.PaperType = 'a5';
f.PaperSize = f.PaperSize ./ [1 1.8];
f.PaperOrientation = 'portrait';
%print(['../plots/quantization/q_all_norm'],'-dpdf','-fillpage');