clear all; close all;
load('raw_data.mat');
load('../data/blossom.mat');
load('slope_data.mat');


%%
d_tanh = reshape(data_tf_test_pth(:,:,:,1,:),4,[],1);
d_sqnl = reshape(data_tf_test_pth(:,:,:,2,:),4,[],1);
d_relu = reshape(data_tf_test_pth(:,:,:,3,:),4,[],1);
d_rot = reshape(data_tf_test_pth(:,:,:,:,2),4,[],1);
d_unrot = reshape(data_tf_test_pth(:,:,:,:,1),4,[],1);
d_rot_sqnl = reshape(data_tf_test_pth(:,:,:,2,2),4,[],1);
d_unrot_sqnl = reshape(data_tf_test_pth(:,:,:,2,1),4,[],1);
d_tf_sqnl = d_sqnl./d_tanh;
d_tf_relu = d_relu./d_tanh;
d_r = d_rot./d_unrot;
d_r_sqnl = d_rot_sqnl./d_unrot_sqnl;

s_tanh = reshape(data_tf_test_slope(:,:,:,1,:),4,[],1);
s_sqnl = reshape(data_tf_test_slope(:,:,:,2,:),4,[],1);
s_relu = reshape(data_tf_test_slope(:,:,:,3,:),4,[],1);
s_rot = reshape(data_tf_test_slope(:,:,:,:,2),4,[],1);
s_unrot = reshape(data_tf_test_slope(:,:,:,:,1),4,[],1);
s_rot_sqnl = reshape(data_tf_test_slope(:,:,:,2,2),4,[],1);
s_unrot_sqnl = reshape(data_tf_test_slope(:,:,:,2,1),4,[],1);
s_tf_sqnl = s_sqnl./s_tanh;
s_tf_relu = s_relu./s_tanh;
s_r = s_rot./s_unrot;
s_r_sqnl = s_rot_sqnl./s_unrot_sqnl;

%%
postf = d_sqnl > 0 & d_tanh > 0 & s_sqnl > 0 & s_tanh > 0;
postfr = d_relu > 0 & d_tanh > 0 & s_relu > 0 & s_tanh > 0;
posrot = d_rot > 0 & d_unrot > 0 & s_rot > 0 & s_unrot > 0;
posrot_sqnl = d_rot_sqnl > 0 & d_unrot_sqnl > 0 & s_rot_sqnl > 0 & s_unrot_sqnl > 0;

avg_d_tfs_tot = exp( sum(log(d_tf_sqnl(postf)),'all')  ./sum(postf,'all'));
avg_s_tfs_tot = exp( sum(log(s_tf_sqnl(postf)),'all')  ./sum(postf,'all'));
avg_d_tfr_tot = exp( sum(log(d_tf_relu(postfr)),'all')./sum(postfr,'all'));
avg_s_tfr_tot = exp( sum(log(s_tf_relu(postfr)),'all')./sum(postfr,'all'));
avg_d_r_tot = exp( sum(log(d_r(posrot)),'all')  ./sum(posrot,'all'));
avg_s_r_tot = exp( sum(log(s_r(posrot)),'all')  ./sum(posrot,'all'));
avg_d_r_sqnl_tot = exp( sum(log(d_r_sqnl(posrot_sqnl)),'all')  ./sum(posrot_sqnl,'all'));
avg_s_r_sqnl_tot = exp( sum(log(s_r_sqnl(posrot_sqnl)),'all')  ./sum(posrot_sqnl,'all'));

for id = 1:size(d,2)
    avg_d_tfs(id) = exp( sum(log(d_tf_sqnl(id,postf(id,:))),'all')  ./sum(postf(id,:),'all'));
    avg_s_tfs(id) = exp( sum(log(s_tf_sqnl(id,postf(id,:))),'all')  ./sum(postf(id,:),'all'));
    avg_d_tfr(id) = exp( sum(log(d_tf_relu(id,postfr(id,:))),'all')  ./sum(postfr(id,:),'all'));
    avg_s_tfr(id) = exp( sum(log(s_tf_relu(id,postfr(id,:))),'all')  ./sum(postfr(id,:),'all'));
    avg_d_r(id) = exp( sum(log(d_r(id,posrot(id,:))),'all')  ./sum(posrot(id,:),'all'));
    avg_s_r(id) = exp( sum(log(s_r(id,posrot(id,:))),'all')  ./sum(posrot(id,:),'all'));
    avg_d_r_sqnl(id) = exp( sum(log(d_r_sqnl(id,posrot_sqnl(id,:))),'all')  ./sum(posrot_sqnl(id,:),'all'));
    avg_s_r_sqnl(id) = exp( sum(log(s_r_sqnl(id,posrot_sqnl(id,:))),'all')  ./sum(posrot_sqnl(id,:),'all'));
end

%%
figure;
subplot(211);
loglog([min(d_tf_sqnl(postf),[],'all') max(d_tf_sqnl(postf),[],'all')],[1 1],'k',...
    [1 1],[max(s_tf_sqnl(postf),[],'all') min(s_tf_sqnl(postf),[],'all')],'k',...
    [min(d_tf_sqnl(postf),[],'all') max(d_tf_sqnl(postf),[],'all')],[avg_s_tfs_tot avg_s_tfs_tot],'k:',...
    [avg_d_tfs_tot avg_d_tfs_tot],[max(s_tf_sqnl(postf),[],'all') min(s_tf_sqnl(postf),[],'all')],'k:');
hold on;
subplot(212);
loglog([min(d_r(posrot),[],'all') max(d_r(posrot),[],'all')],[1 1],'k',...
    [1 1],[max(s_r(posrot),[],'all') min(s_r(posrot),[],'all')],'k',...
    [min(d_r(posrot),[],'all') max(d_r(posrot),[],'all')],[avg_s_r_tot avg_s_r_tot],'k:',...
    [avg_d_r_tot avg_d_r_tot],[max(s_r(posrot),[],'all') min(s_r(posrot),[],'all')],'k:');
hold on;
for id = 1:size(d,2) 
    subplot(211);
    loglog(d_tf_sqnl(id,postf(id,:)),s_tf_sqnl(id,postf(id,:)),'.','Color',c(id,:));
    loglog( [min(d_tf_sqnl(postf),[],'all') max(d_tf_sqnl(postf),[],'all')],[avg_s_tfs(id) avg_s_tfs(id)],':','Color',c(id,:));
    loglog( [avg_d_tfs(id) avg_d_tfs(id)],[max(s_tf_sqnl(postf),[],'all') min(s_tf_sqnl(postf),[],'all')],':','Color',c(id,:));
    %grid on;
    %axis square;
    subplot(212);
    loglog(d_r(id,posrot(id,:)),s_r(id,posrot(id,:)),'.','Color',c(id,:));
    loglog( [min(d_r(posrot),[],'all') max(d_r(posrot),[],'all')],[avg_s_r(id) avg_s_r(id)],':','Color',c(id,:));
    loglog( [avg_d_r(id) avg_d_r(id)],[max(s_r(posrot),[],'all') min(s_r(posrot),[],'all')],':','Color',c(id,:));
    %grid on;
    %axis square;
end