clear all;
load('raw_data.mat');
load('../data/blossom.mat');
close all;

%tf = [1 3];
%rot = [0 1];
marker = ['s','d','o'];

for id = 1:size(d,2)
   
    
    f = figure(id);
    subplot(211);  
    loglog(ls1,ones(1,size(ls1,2)),'k--');
    hold on;
    for i2 = 1:size(ls2,2)
            for irot = 1:size(rot,2)
                plotdata = squeeze(data_tf_test_pth(id,:,i2,2,irot))./squeeze(data_tf_test_pth(id,:,i2,1,irot));
                iidata = (plotdata > 0 & plotdata ~= Inf & ~isnan(plotdata));
                loglog(ls1(iidata),plotdata(iidata),['-' marker(irot)],'color',c(i2,:));
            end
            plotdata = squeeze(data_tf_test_pth(id,:,i2,3,2))./squeeze(data_tf_test_pth(id,:,i2,1,2));
            iidata = (plotdata > 0 & plotdata ~= Inf & ~isnan(plotdata));
            loglog([ls1(iidata)],[plotdata(iidata)],['-' marker(3)],'color',c(i2,:));
    end
    xlabel('Layer Size 1');
    ylabel('Pth(SQNL) / Pth(TanH)');
    title(['Distance ' num2str(d(id))]);
    grid on;
    xticks(ls1);
    xticklabels(ls1);
    %leg = cell(1 + size(ls2,2),1);
    leg = cell(1+ 3*size(ls2,2),1);
    leg(1) = {'Baseline'};
    for i2 = 1:size(ls2,2)
        leg(3*(i2-1)+2:3*(i2-1)+4) = {num2str(ls2(i2));[num2str(ls2(i2)) ' Rot'];[num2str(ls2(i2)) ' ReLU']};
    end
    %leg(2:end) = mat2cell(num2str(ls2'),ones(1,size(ls2,2)),size(num2str(ls2'),2))';
    legend(leg, 'Location', 'SouthWest','FontSize',7);
    
    subplot(212);    
    loglog(ls1,ones(1,size(ls1,2)),'k--');
    hold on;
    for i2 = 1:size(ls2,2)
            for itf = 1:size(tf,2)-1
                plotdata = squeeze(data_tf_test_pth(id,:,i2,itf,2))./squeeze(data_tf_test_pth(id,:,i2,itf,1));
                iidata = (plotdata > 0 & plotdata ~= Inf & ~isnan(plotdata));
                loglog(ls1(iidata),plotdata(iidata),['-' marker(itf)],'color',c(i2,:));
            end
    end
    xlabel('Layer Size 1');
    ylabel('Pth(Rot) / Pth(Unrot)');
    title(['Distance ' num2str(d(id))]);
    grid on;
    xticks(ls1);
    xticklabels(ls1);
    %leg = cell(1 + size(ls2,2),1);
    leg = cell(1+ 2*size(ls2,2),1);
    leg(1) = {'Baseline'};
    for i2 = 1:size(ls2,2)
        leg(2*i2:2*i2+1) = {[num2str(ls2(i2)) 'TanH'];[num2str(ls2(i2)) 'SQNL']};
    end
    %leg(2:end) = mat2cell(num2str(ls2'),ones(1,size(ls2,2)),size(num2str(ls2'),2))';
    legend(leg, 'Location', 'SouthWest','FontSize',7);
    
    
    f.PaperType = 'a5';
    f.PaperSize = f.PaperSize ./ [1 1.8];
    f.PaperOrientation = 'portrait';
    %print(['../plots/transfer_function/tf_d' num2str(d(id))],'-dpdf','-fillpage');
end