clear all;
close all;

for mode = 1:3
    if(mode == 1)
        NN = [8 24 48 80];
        WB = [2 3 4 5 6 7 8 9];
        IB = [1 1 1 1 1 1 1 1];
        OB = WB;
    elseif(mode == 2)
        NN = [4 8 16 32 64 128 256];
        WB = [2 3 4 5 6 7 8 9];
        IB = WB;
        OB = WB;
    else
        NN = [4 8 16 32 64];
        WB = [2 3 4 5 6 7 8 9];
        IB = WB;
        OB = [1 1 1 1 1 1 1 1];
    end
    for nn = NN
        for k = 1:numel(WB)
            wb = WB(k);
            ib = IB(k);
            ob = OB(k);
            
            
            %% timing
            % read file
            fid = fopen(['../data/data_hardware/node_' num2str(nn) '_' num2str(wb) '_' num2str(ib) '_' num2str(floor(log2(nn))+wb+ib) '_' num2str(ob) '.txt']);
            if(fid == -1)
                disp(['Could not find file: ../data/data_hardware/node_' num2str(nn) '_' num2str(wb) '_' num2str(ib) '_' num2str(floor(log2(nn))+wb+ib) '_' num2str(ob) '.txt']);
            else
                fclose(fid);
                filetext = fileread(['../data/data_hardware/node_' num2str(nn) '_' num2str(wb) '_' num2str(ib) '_' num2str(floor(log2(nn))+wb+ib) '_' num2str(ob) '.txt']);
                exprtime = 'Data Path:-\s+\d+';
                matchtime = regexp(filetext, exprtime, 'match');
                matchtime = split(matchtime(1,1));
                data_time(nn,wb,ib,ob) = str2double(cell2mat(matchtime(3,1)));

                %% area and power
                % read file
                %filetext = fileread(['node_' num2str(nn) '_' num2str(wb) '_' num2str(ib) '_' num2str(floor(log2(nn))+wb+ib) '_' num2str(ob) '_reports.txt']);
                % define expressions
                exprseq = 'sequential\s+\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+';
                exprinv = 'inverter\s+\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+';
                exprlog = 'logic\s+\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+';
                exprtot = 'total\s+\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+\d+.\d+\s+';

                % split and find expressions
                matchseq = split(regexp(filetext, exprseq, 'match'));
                matchinv = split(regexp(filetext, exprinv, 'match'));
                matchlog = split(regexp(filetext, exprlog, 'match'));
                matchtot = split(regexp(filetext, exprtot, 'match'));

                % extract data
                data_area_seq(nn,wb,ib,ob) = str2double(cell2mat(matchseq(3,1)));
                data_area_log(nn,wb,ib,ob) = str2double(cell2mat(matchinv(3,1)))+str2double(cell2mat(matchlog(3,1)));
                data_area_tot(nn,wb,ib,ob) = str2double(cell2mat(matchtot(3,1)));

                data_power_leak_seq(nn,wb,ib,ob) = str2double(cell2mat(matchseq(5,1)));
                data_power_leak_log(nn,wb,ib,ob) = str2double(cell2mat(matchinv(5,1)))+str2double(cell2mat(matchlog(5,1)));
                data_power_leak_tot(nn,wb,ib,ob) = str2double(cell2mat(matchtot(5,1)));

                data_power_dyn_seq(nn,wb,ib,ob) = str2double(cell2mat(matchseq(7,1)));
                data_power_dyn_log(nn,wb,ib,ob) = str2double(cell2mat(matchinv(7,1)))+str2double(cell2mat(matchlog(7,1)));
                data_power_dyn_tot(nn,wb,ib,ob) = str2double(cell2mat(matchtot(7,1)));

                data_power_seq(nn,wb,ib,ob) = data_power_leak_seq(nn,wb,ib,ob) + data_power_dyn_seq(nn,wb,ib,ob);
                data_power_log(nn,wb,ib,ob) = data_power_leak_log(nn,wb,ib,ob) + data_power_dyn_log(nn,wb,ib,ob);
                data_power_tot(nn,wb,ib,ob) = data_power_leak_tot(nn,wb,ib,ob) + data_power_dyn_tot(nn,wb,ib,ob);
            end
        end
    end
end

NN = [2 4 8 16 32 64 128 256];
NNin = [8 24 48 80];

for k = 1:numel(NN)
for m = 1:numel(WB)
    data(m,k) = data_power_dyn_log(NN(k),WB(m),WB(m),WB(m));
    dataout(m,k) = data_power_dyn_log(NN(k),WB(m),WB(m),1);
   
    alpha = 28.9298-2*17.28;
    beta = -14.5;
    gamma = 17.28;
    datar(m,k) = alpha * WB(m)^2 + beta * WB(m) + gamma * WB(m)*WB(m)*NN(k);
    datarout(m,k) = 2*alpha * WB(m)^2 + 3*beta * WB(m) + gamma * WB(m)*WB(m)*NN(k);
end
end

for k = 1:numel(NNin)
for m = 1:numel(WB)
    datain(m,k) = data_power_log(NNin(k),WB(m),1,WB(m));
    datarin(m,k) = 10 * WB(m)^2 + 10 * WB(m) * ( -4 + 0.135 * gamma * NNin(k) );
end
end

figure
subplot(231)
semilogy(WB,datain,'o-','LineWidth',2)
subplot(232)
semilogy(WB,data,'o-','LineWidth',2)
title('Power')
subplot(233)
semilogy(WB,dataout,'o-','LineWidth',2)
subplot(234)
loglog(NNin,datain','o-','LineWidth',2)
subplot(235)
loglog(NN,data','o-','LineWidth',2)
subplot(236)
loglog(NN,dataout','o-','LineWidth',2)

figure
subplot(221);
plot(WB,data,'d',WB,datar,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
subplot(222);
semilogy(WB,data,'d',WB,datar,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
title('Power');
subplot(223);
plot(NN,data,'d',NN,datar,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NN,data,'d',NN,datar,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
figure
subplot(221);
plot(WB,dataout,'d',WB,datarout,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
subplot(222);
semilogy(WB,dataout,'d',WB,datarout,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
title('PowerOut');
subplot(223);
plot(NN,dataout,'d',NN,datarout,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NN,dataout,'d',NN,datarout,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
figure
subplot(221);
plot(WB,datain,'d',WB,datarin,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('8','24','48','80','Model','Location','EastOutside');
subplot(222);
semilogy(WB,datain,'d',WB,datarin,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('8','24','48','80','Model','Location','EastOutside');
title('PowerIn');
subplot(223);
plot(NNin,datain,'d',NNin,datarin,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NNin,datain,'d',NNin,datarin,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');

for k = 1:numel(NN)
for m = 1:numel(WB)
    data(m,k) = data_area_log(NN(k),WB(m),WB(m),WB(m));
    dataout(m,k) = data_area_log(NN(k),WB(m),WB(m),1);
    
    alpha = 15;
    beta = -30;
    gamma = 5.15;
    datar(m,k) = alpha * WB(m)^2 + beta * WB(m) + gamma * WB(m)*WB(m)*NN(k);
    datarout(m,k) = alpha * WB(m)^2 + beta * WB(m) + gamma * WB(m)*WB(m)*NN(k);
    
end
end

for k = 1:numel(NNin)
for m = 1:numel(WB)
    datain(m,k) = data_area_log(NNin(k),WB(m),1,WB(m));
    datarin(m,k) = alpha * WB(m)^2 + beta * WB(m) + gamma * WB(m)*WB(m)*NNin(k);
end
end


figure
subplot(231)
semilogy(WB,datain,'o-','LineWidth',2)
subplot(232)
semilogy(WB,data,'o-','LineWidth',2)
title('Area')
subplot(233)
semilogy(WB,dataout,'o-','LineWidth',2)
subplot(234)
loglog(NNin,datain','o-','LineWidth',2)
subplot(235)
loglog(NN,data','o-','LineWidth',2)
subplot(236)
loglog(NN,dataout','o-','LineWidth',2)

figure
subplot(221);
plot(WB,data,'d',WB,datar,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
subplot(222);
semilogy(WB,data,'d',WB,datar,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
title('Area');
subplot(223);
plot(NN,data,'d',NN,datar,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NN,data,'d',NN,datar,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
figure
subplot(221);
plot(WB,dataout,'d',WB,datarout,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
subplot(222);
semilogy(WB,dataout,'d',WB,datarout,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
title('AreaOut');
subplot(223);
plot(NN,dataout,'d',NN,datarout,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NN,dataout,'d',NN,datarout,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
figure
subplot(221);
plot(WB,datain,'d',WB,datarin,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('8','24','48','80','Model','Location','EastOutside');
subplot(222);
semilogy(WB,datain,'d',WB,datarin,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('8','24','48','80','Model','Location','EastOutside');
title('AreaIn');
subplot(223);
plot(NNin,datain,'d',NNin,datarin,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NNin,datain,'d',NNin,datarin,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');

for k = 1:numel(NN)
for m = 1:numel(WB)
    data(m,k) = data_time(NN(k),WB(m),WB(m),WB(m));
    dataout(m,k) = data_time(NN(k),WB(m),WB(m),1);
    
    alpha = 1100;
    beta = 500;
    datar(m,k) = alpha * (WB(m) - 1) + beta * log2(NN(k) - 1);
    datarout(m,k) = alpha * (WB(m) - 1) + beta * log2(NN(k) - 1);
end
end

for k = 1:numel(NNin)
for m = 1:numel(WB)
    datain(m,k) = data_time(NNin(k),WB(m),1,WB(m));
    datarin(m,k) = alpha * (WB(m) - 1) + beta * log2(NNin(k) - 1);
    
end
end

figure
subplot(231)
semilogy(WB,datain,'o-','LineWidth',2)
subplot(232)
semilogy(WB,data,'o-','LineWidth',2)
title('Delay')
subplot(233)
semilogy(WB,dataout,'o-','LineWidth',2)
subplot(234)
loglog(NNin,datain','o-','LineWidth',2)
subplot(235)
loglog(NN,data','o-','LineWidth',2)
subplot(236)
loglog(NN,dataout','o-','LineWidth',2)

figure
subplot(221);
plot(WB,data,'d',WB,datar,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
subplot(222);
semilogy(WB,data,'d',WB,datar,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
title('Delay');
subplot(223);
plot(NN,data,'d',NN,datar,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NN,data,'d',NN,datar,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
figure
subplot(221);
plot(WB,dataout,'d',WB,datarout,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
subplot(222);
semilogy(WB,dataout,'d',WB,datarout,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('2','4','8','16','32','64','128','256','Model','Location','EastOutside');
title('DelayOut');
subplot(223);
plot(NN,dataout,'d',NN,datarout,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NN,dataout,'d',NN,datarout,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
figure
subplot(221);
plot(WB,datain,'d',WB,datarin,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('8','24','48','80','Model','Location','EastOutside');
subplot(222);
semilogy(WB,datain,'d',WB,datarin,'k-','LineWidth',1);
xlabel('Number of Bits');
legend('8','24','48','80','Model','Location','EastOutside');
title('DelayIn');
subplot(223);
plot(NNin,datain,'d',NNin,datarin,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');
subplot(224);
loglog(NNin,datain,'d',NNin,datarin,'k-','LineWidth',1);
xlabel('Input Size');
legend('2','3','4','5','6','7','8','9','Model','Location','EastOutside');

%% Configurations.
x = [3 5 7 9];
s = [8 32 128 256];
for k = 1:numel(x)
for m = 1:numel(WB)
   datapowertot(k,m) = s(k)*data_power_log(NNin(k),WB(m),1,WB(m)) + 16*data_power_log(s(k),WB(m),WB(m),WB(m)) + 2*data_power_log(16,WB(m),WB(m),1);
   dataareatot(k,m) = s(k)*data_area_log(NNin(k),WB(m),1,WB(m)) + 16*data_area_log(s(k),WB(m),WB(m),WB(m)) + 2*data_area_log(16,WB(m),WB(m),1);
   datatimetot(k,m) = data_time(NNin(k),WB(m),1,WB(m)) + data_time(s(k),WB(m),WB(m),WB(m)) + data_time(16,WB(m),WB(m),1);
end
end
figure('DefaultAxesFontSize',16)
ax = subplot(131);
semilogy(x,datapowertot/1e9,'o-','LineWidth',2);
hold on;
semilogy([3 5 5 7 7 9 9],[13291 89705 432630 541891 3973881 1600817 11717942]/1e9,'kx','LineWidth',2);
semilogy([3 3;5 5; 5 5; 7 7;7 7;9 9;9 9]',[13291 datapowertot(1,1);89705 datapowertot(2,1);432630 datapowertot(2,4);541891 datapowertot(3,1);3973881 datapowertot(3,5);1600817 datapowertot(4,1);11717942 datapowertot(4,5)]'/1e9,'k','LineWidth',1);
xlabel('Surface Code Distance');
ylabel('Power [ W ]');
xlim([2,10]);
xticks([3 5 7 9]);
grid on;
title('Power'); 
ax.LineWidth = 1;
legend('2 bits','3 bits','4 bits','5 bits','6 bits','7 bits', '8 bits','Location','SouthEast');

ax = subplot(132);
semilogy(x,dataareatot/1e6,'o-','LineWidth',2);
hold on;
semilogy([3 5 5 7 7 9 9],[2498 17990 81664 119871 704018 366196 2051126]/1e6,'kx','LineWidth',2);
semilogy([3 3;5 5; 5 5; 7 7;7 7;9 9;9 9]',[2498 dataareatot(1,1);17990 dataareatot(2,1);81664 dataareatot(2,4);119871 dataareatot(3,1);704018 dataareatot(3,5);366196 dataareatot(4,1);2051126 dataareatot(4,5)]'/1e6,'k','LineWidth',1);
xlabel('Surface Code Distance');
ylabel('Area [ mm2 ]');
xlim([2,10]);
xticks([3 5 7 9]);
grid on;
title('Area');
ax.LineWidth = 1;
legend('2 bits','3 bits','4 bits','5 bits','6 bits','7 bits', '8 bits','Location','SouthEast');

ax = subplot(133);
semilogy(x,datatimetot/1000,'o-','LineWidth',2);
hold on;
semilogy([3 5 5 7 7 9 9],[6798 9825 20588 11113 24157 12329 25836]/1000,'kx','LineWidth',2);
semilogy([3 3;5 5; 5 5; 7 7;7 7;9 9;9 9]',[6798 datatimetot(1,1);9825 datatimetot(2,1);20588 datatimetot(2,4);11113 datatimetot(3,1);24157 datatimetot(3,5);12329 datatimetot(4,1);25836 datatimetot(4,5)]'/1000,'k','LineWidth',1);
xlabel('Surface Code Distance');
ylabel('Delay [ ns ]');
xlim([2,10]);
xticks([3 5 7 9]);
grid on;
title('Delay');
ax.LineWidth = 1;
legend('2 bits','3 bits','4 bits','5 bits','6 bits','7 bits', '8 bits','Location','SouthEast');

save('../data/data_hardware/data_node_area.mat',...
    'data_area_log',...
    'data_area_tot');
save('../data/data_hardware/data_node_power_dyn.mat',...
    'data_power_dyn_log',...
    'data_power_dyn_seq',...
    'data_power_dyn_tot');
save('../data/data_hardware/data_node_power_leak.mat',...
    'data_power_leak_log',...
    'data_power_leak_seq',...
    'data_power_leak_tot');
save('../data/data_hardware/data_node_power_tot.mat',...
    'data_power_log',...
    'data_power_seq',...
    'data_power_tot');
 save('../data/data_hardware/data_node_time.mat',...
    'data_time');