clear all;
close all;

Nx = 21;

d = [3 3 5 7 9];          % distances
ls0 = d.^2 - 1;         % inputs
ls1 = [8 16 64 256 128];   % corresponding layer size 1
ls2 = [4 4 64 64 64];     % corresponding layer size 2
q = [4 16 8 16 64];        % regularization quantization levels (fractional)
b = [3 5 4 5 7];          % bits for fixed point quantization (total)

for ii = 1:size(d,2)
    fid = fopen(['../data/training_data/d' num2str(d(ii)) '_q' num2str(q(ii)) '_' num2str(ls1(ii)) '_' num2str(ls2(ii)) '_t3_r1']);
    if(fid == -1)
        disp(['Could not find file: ../data/training_data/d' num2str(d(ii)) '_q' num2str(q(ii)) '_' num2str(ls1(ii)) '_' num2str(ls2(ii)) '_t3_r1']);
    else
        fclose(fid);
        filetext = fileread(['../data/training_data/d' num2str(d(ii)) '_q' num2str(q(ii)) '_' num2str(ls1(ii)) '_' num2str(ls2(ii)) '_t3_r1']);
        
        expr_weights = ['w\[\d+\s+\d+\s+\d+\]\s+=\s+.?\d+.\d+,\s+.?\d+.\d+\s+'];
        
        match_weights = split(regexp(filetext, expr_weights , 'match'));
        
        w = ['reg [' num2str(b(ii)*(ls0(ii)*ls1(ii)+ls1(ii)*ls2(ii)+ls2(ii)*2)-1) ':0] weights = ' num2str(b(ii)*(ls0(ii)*ls1(ii)+ls1(ii)*ls2(ii)+ls2(ii)*2)) '''b'];
        bias = ['reg [' num2str(b(ii)*(ls1(ii)+ls2(ii)+2)-1) ':0] bias = ' num2str(b(ii)*(ls1(ii)+ls2(ii)+2)) '''b'];
        
        
        % output layer
        for jj = 1:-1:0
            for kk = ls2(ii)-1:-1:0
                nn = 1+(ls0(ii)+1)*ls1(ii) + (ls1(ii)+1)*ls2(ii) + jj*(ls2(ii)+1) + kk;
                if(strcmp(match_weights(1,nn,1),['w[' num2str(2)]) && strcmp(match_weights(1,nn,2),['' num2str(jj)]) && strcmp(match_weights(1,nn,3), [num2str(kk) ']']))
                    ws = cell2mat(match_weights(1,nn,5));
                    ws = str2double(ws(1:end-1));
                    ws = round(ws*2^(b(ii)-1));
                    if(ws >= 0)
                        w = [w '0' dec2bin(ws,b(ii)-1)];
                    else
                        w = [w '1' dec2bin((2^(b(ii)-1)+ws),b(ii)-1)];
                    end
                else
                    disp(['Error: w[' num2str(2) ' ' num2str(jj) ' ' num2str(kk) '] at: ' num2str(nn) ': ' cell2mat(match_weights(1,nn,1)) ' ' cell2mat(match_weights(1,nn,2)) ' ' cell2mat(match_weights(1,nn,3))]);
                end
            end
            kk = ls2(ii);
            nn = 1+(ls0(ii)+1)*ls1(ii) + (ls1(ii)+1)*ls2(ii) + jj*(ls2(ii)+1) + kk;
            if(strcmp(match_weights(1,nn,1),['w[' num2str(2)]) && strcmp(match_weights(1,nn,2),['' num2str(jj)]) && strcmp(match_weights(1,nn,3), [num2str(kk) ']']))
                ws = cell2mat(match_weights(1,nn,5));
                ws = str2double(ws(1:end-1));
                ws = round(ws*2^(b(ii)-1));
                if(ws >= 0)
                    bias = [bias '0' dec2bin(ws,b(ii)-1)];
                else
                    bias = [bias '1' dec2bin((2^(b(ii)-1)+ws),b(ii)-1)];
                end
            else
                disp(['Error: w[' num2str(2) ' ' num2str(jj) ' ' num2str(kk) '] at: ' num2str(nn) ': ' cell2mat(match_weights(1,nn,1)) ' ' cell2mat(match_weights(1,nn,2)) ' ' cell2mat(match_weights(1,nn,3))]);
            end
        end
        
        % layer 2
        for jj = ls2(ii)-1:-1:0
            for kk = ls1(ii)-1:-1:0           
                nn = 1+(ls0(ii)+1)*ls1(ii) + jj*(ls1(ii)+1) + kk;                
                if(strcmp(match_weights(1,nn,1),['w[' num2str(1)]) && strcmp(match_weights(1,nn,2),['' num2str(jj)]) && strcmp(match_weights(1,nn,3), [num2str(kk) ']']))
                    ws = cell2mat(match_weights(1,nn,5));
                    ws = str2double(ws(1:end-1));
                    ws = round(ws*2^(b(ii)-1));
                    if(ws >= 0)
                        w = [w '0' dec2bin(ws,b(ii)-1)];
                    else
                        w = [w '1' dec2bin((2^(b(ii)-1)+ws),b(ii)-1)];
                    end
                else
                    disp(['Error: w[' num2str(1) ' ' num2str(jj) ' ' num2str(kk) '] at: ' num2str(nn) ': ' cell2mat(match_weights(1,nn,1)) ' ' cell2mat(match_weights(1,nn,2)) ' ' cell2mat(match_weights(1,nn,3))]);
                end
            end
            kk = ls1(ii);
            nn = 1+(ls0(ii)+1)*ls1(ii) + jj*(ls1(ii)+1) + kk;   
            if(strcmp(match_weights(1,nn,1),['w[' num2str(1)]) && strcmp(match_weights(1,nn,2),['' num2str(jj)]) && strcmp(match_weights(1,nn,3), [num2str(kk) ']']))
                ws = cell2mat(match_weights(1,nn,5));
                ws = str2double(ws(1:end-1));
                ws = round(ws*2^(b(ii)-1));
                if(ws >= 0)
                    bias = [bias '0' dec2bin(ws,b(ii)-1)];
                else
                    bias = [bias '1' dec2bin((2^(b(ii)-1)+ws),b(ii)-1)];
                end
            else
                disp(['Error: w[' num2str(1) ' ' num2str(jj) ' ' num2str(kk) '] at: ' num2str(nn) ': ' cell2mat(match_weights(1,nn,1)) ' ' cell2mat(match_weights(1,nn,2)) ' ' cell2mat(match_weights(1,nn,3))]);
            end          
        end
        
        % layer 1
        for jj = ls1(ii)-1:-1:0
            for kk = ls0(ii)-1:-1:0
                nn = 1 + jj*(ls0(ii)+1) + kk;                
                if(strcmp(match_weights(1,nn,1),['w[' num2str(0)]) && strcmp(match_weights(1,nn,2),['' num2str(jj)]) && strcmp(match_weights(1,nn,3), [num2str(kk) ']']))
                    ws = cell2mat(match_weights(1,nn,5));
                    ws = str2double(ws(1:end-1));
                    ws = round(ws*2^(b(ii)-1));
                    if(ws >= 0)
                        w = [w '0' dec2bin(ws,b(ii)-1)];
                    else
                        w = [w '1' dec2bin((2^(b(ii)-1)+ws),b(ii)-1)];
                    end
                else
                    disp(['Error: w[' num2str(0) ' ' num2str(jj) ' ' num2str(kk) '] at: ' num2str(nn) ': ' cell2mat(match_weights(1,nn,1)) ' ' cell2mat(match_weights(1,nn,2)) ' ' cell2mat(match_weights(1,nn,3))]);
                end
            end
            kk = ls0(ii);
            nn = 1 + jj*(ls0(ii)+1) + kk;     
            if(strcmp(match_weights(1,nn,1),['w[' num2str(0)]) && strcmp(match_weights(1,nn,2),['' num2str(jj)]) && strcmp(match_weights(1,nn,3), [num2str(kk) ']']))
                ws = cell2mat(match_weights(1,nn,5));
                ws = str2double(ws(1:end-1));
                ws = round(ws*2^(b(ii)-1));
                if(ws >= 0)
                    bias = [bias '0' dec2bin(ws,b(ii)-1)];
                else
                    bias = [bias '1' dec2bin((2^(b(ii)-1)+ws),b(ii)-1)];
                end
            else
                disp(['Error: w[' num2str(0) ' ' num2str(jj) ' ' num2str(kk) '] at: ' num2str(nn) ': ' cell2mat(match_weights(1,nn,1)) ' ' cell2mat(match_weights(1,nn,2)) ' ' cell2mat(match_weights(1,nn,3))]);
            end  
        end
        
        weights(ii) = {[w ';']};
        biases(ii) = {[bias ';']};
        
        %disp(w);
        %disp(bias);
    end
end